<?php

namespace Mbl\Membergroup;

use WP_Term;

class Chat
{
    private int $id;

    public function __construct(int $id)
    {
        $this->id = $id;
    }

	/**
	 * @throws ChatNotFoundError
	 * @throws NoRightsManageInviteLinks
	 */
    public function inviteLink(WP_Term $term): string
    {
        $chats = get_option('tg_admin_chats');
        if (!isset($chats[$this->id])) {
            throw new ChatNotFoundError("Chat $this->id not found");
        }
        $chat = $chats[$this->id];
        $chat_id = $chat['chat_id'];
        if (!isset($chat['links'])) {
            $chat['links'] = [];
        }
        if (!isset($chat['links'][$term->term_id])) {
            $req = tg_request('createChatInviteLink',
                ['chat_id' => $chat_id, 'name' => $term->name, 'creates_join_request' => true]
            );
			if(!$req->ok) {
				throw new NoRightsManageInviteLinks($req->description);
			}
	        $chats[$this->id]['links'][$term->term_id] = $req->result->invite_link;
	        update_option('tg_admin_chats', $chats);
	        $chat['links'][$term->term_id] = $req->result->invite_link;
        }

        return $chat['links'][$term->term_id];
    }
}